local name, addon = ...
local lpanels = addon['lpanels']
if(not lpanels) then return end
local rilgamonHeight = 200
local rilgamonWidth = rilgamonHeight * 2
local rilgamonTopHeight = 22

lpanels:CreateLayout("Rilgamon", {
	-- Create a global layout right here
	{
		name = "TopGradient",
		strata = "BACKGROUND", level = 0,
		height = rilgamonTopHeight, width = "100%",
		anchor_to = "TOP",
		bg_color = "0 0 0 1",
		bg_alpha = 1,
		gradient = "V",
		gradient_color = "CLASS",
		gradient_alpha = .8,
	}, {
		name = "ClassLine",
		strata = "BACKGROUND",
		x_off = 0, y_off = rilgamonHeight,
		level = 0,
		bg_color = "CLASS",
		bg_alpha = 1,
		anchor_to = "BOTTOM",
		width = "100%",
		height = 1,
	}, {
		name = "ClassGradient", parent = "ClassLine",
		strata = "BACKGROUND", level = 0,
		width = "100%",
		height = rilgamonHeight,
		y_off = -1,
		anchor_to = "TOP",
		bg_color = "CLASS",
		bg_alpha = .5,
		gradient = "V",
		gradient_color = "0 0 0 .5",
		gradient_alpha = .5,
	}, {
		name = "BlackBoxLeft", parent = "ClassLine",
		strata = "BACKGROUND", level = 2,
		width = rilgamonWidth, height = rilgamonHeight,
		y_off = -1,
		bg_color = "0 0 0 1",
		bg_alpha = 1,
		anchor_to = "TOPLEFT",
	}, {
		name = "BlackBoxRight", parent = "ClassLine",
		strata = "BACKGROUND", level = 2,
		width = rilgamonWidth, height = rilgamonHeight,
		y_off = -1,
		bg_color = "0 0 0 1",
		bg_alpha = 1,
		anchor_to = "TOPRIGHT",
	}, {
		name = "GradientLeft", parent = "BlackBoxLeft",
		strata = "BACKGROUND", level = 1,
		width = rilgamonWidth, height = rilgamonHeight,
		anchor_to = "LEFT",
		anchor_from = "RIGHT",
		bg_color = "0 0 0 1",
		bg_alpha = 1,
		gradient = "H",
		gradient_color = "CLASS",
		gradient_alpha = 0,
	}, {
		name = "GradientRight", parent = "BlackBoxRight",
		strata = "BACKGROUND", level = 1,
		width = rilgamonWidth, height = rilgamonHeight,
		anchor_to = "RIGHT",
		anchor_from = "LEFT",
		bg_color = "CLASS",
		bg_alpha = 0,
		gradient = "H",
		gradient_color = "0 0 0 1",
		gradient_alpha = 1,
	}
}
-- , { bottom = rilgamonHeight, top = rilgamonTopHeight } -- Viewport - delete this line for no viewport

)

lpanels:ApplyLayout(nil, "Rilgamon")


